<?php

namespace Schaffen\ServiceOrder\ServiceOrder\Models;


use Illuminate\Database\Eloquent\Model;
use Schaffen\Core\Person\Models\Person;
use Schaffen\Core\Person\Traits\HasPerson;
use Schaffen\Core\Product\Traits\HasProduct;
use Schaffen\ServiceOrder\ServiceOrder\Traits\HasServiceOrder;

class ServiceOrderItemResource extends Model
{
   use HasPerson;

   protected $connection = 'dynamicdb';
   protected $table = "os.osps_recursos";
   protected $primaryKey = "ospsr_codigo";
   protected $fillable = ["ospsr_fk_vendedor_codigo", "ospsr_fk_osps_codigo","ospsr_porcentagem_comissao"];

   const CREATED_AT = "ospsr_date_insert";
   const CREATED_BY = "ospsr_user_insert";
   const UPDATED_AT = "ospsr_date_update";
   const UPDATED_BY = "ospsr_user_update";

   public function person()
   {
      return $this->belongsTo(Person::class, 'ospsr_fk_vendedor_codigo');
   }


}
