<?php

namespace Schaffen\ServiceOrder\ServiceOrder\Models;


use Illuminate\Database\Eloquent\Model;

class ServiceOrderStatus extends Model
{


    const CREATED_AT = "sto_date_insert";
    const UPDATED_AT = "sto_date_update";
    protected $connection = "dynamicdb";
    protected $table = "os.status_os";
    protected $primaryKey = "sto_codigo";
    protected $fillable = [
        "sto_descricao", "sto_permite_edicao_os", "sto_user_insert", "sto_date_insert", "sto_user_update",
        "sto_date_update", "sto_permite_faturamento", "sto_controla_estoque", "sto_tipo_os", "sto_status_inicial",
        "sto_exige_aprovacao_entrada", "sto_permite_solicitacao_compras", "sto_permite_gerar_os_orcamento",
        "sto_fk_tse_codigo", "sto_exige_texto_observacao", "sto_locacao_confirmada", "sto_gera_evento",
        "sto_permite_exclusao", "sto_permite_gerar_comissao", "sto_executado", "sto_excluivel", "sto_exibe_filtros"];

    protected $casts = [
       "sto_executado" => "boolean",
       "sto_excluivel" => "boolean",
       "sto_permite_edicao_os" => "boolean",
       "sto_permite_faturamento" => "boolean",
       "sto_controla_estoque" => "boolean",
       "sto_status_inicial" => "boolean",
       "sto_exige_aprovacao_entrada" => "boolean",
       "sto_permite_solicitacao_compras" => "boolean",
       "sto_permite_gerar_os_orcamento" => "boolean",
       "sto_locacao_confirmada" => "boolean",
       "sto_exibe_filtros" => "boolean",
       "sto_gera_evento" => "boolean",
       "sto_permite_exclusao" => "boolean",
       "sto_permite_gerar_comissao" => "boolean"
    ];

    public function nextStatus()
    {
        return $this->hasMany(Status::class, 'sos_fk_sto_codigo_origem');
    }

}
