<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace Schaffen\ServiceOrder\ServiceOrder\Services;


use Schaffen\Core\Form\Managers\FormAssociationManager;
use Schaffen\Core\Form\Repositories\FormAssociationRepository;
use Schaffen\Core\Form\Repositories\FormRepository;

class CreateOrUpdateServiceOrderForm
{


   /**
    * @var FormRepository
    */
   private FormRepository $form_repository;
   /**
    * @var FormAssociationRepository
    */
   private FormAssociationRepository $form_association_repository;
   /**
    * @var FormAssociationManager
    */
   private FormAssociationManager $form_association_manager;

   public function __construct(
      FormAssociationRepository $form_association_repository,
      FormRepository $form_repository,
      FormAssociationManager $form_association_manager
   )
   {
      $this->form_repository = $form_repository;
      $this->form_association_repository = $form_association_repository;
      $this->form_association_manager = $form_association_manager;
   }

   public function associateForms(
      $forms,
      $service_order_id
   )
   {
      $forms = !is_array($forms) ? [$forms] : $forms;
      $return = [];
      foreach ($forms as $form) {

         $return[] = $this->form_association_manager->answerFormFromEntity($form['foa_respostas'], $service_order_id, $form['form_codigo']);

      }
      return $return;
   }
}
