<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace Schaffen\ServiceOrder\ServiceOrder\Services;


use Schaffen\ServiceOrder\ServiceOrder\Repositories\ServiceOrderItemRepository;

class RemoveServiceOrderItem
{
   /**
    * @var ServiceOrderItemRepository
    */
   private ServiceOrderItemRepository $service_order_item_repository;
   /**
    * @var RemoveServiceOrderItemResources
    */
   private RemoveServiceOrderItemResources $remove_service_order_item_resources;

   public function __construct(
      ServiceOrderItemRepository $service_order_item_repository,
      RemoveServiceOrderItemResources $remove_service_order_item_resources
   )
   {
      $this->service_order_item_repository = $service_order_item_repository;
      $this->remove_service_order_item_resources = $remove_service_order_item_resources;
   }


   public function removeItems($items_to_remove)
   {

      $items_to_remove = is_array($items_to_remove) ? $items_to_remove : [$items_to_remove];
      $err = [];
      try {

         foreach ($items_to_remove as $item_id) {

            $item_db = $this->service_order_item_repository->find($item_id);
            if (!empty($item_db->osps_fk_fat_codigo)) {
               throw new \AlreadyBilled("O item $item_db->complete_name} encontra-se faturado e não pode ser editado (faturamento código {$item_db->osps_fk_fat_codigo}).");
            }

            $this->remove_service_order_item_resources->removeByItem($item_id);
            dump("err");

//            if (!empty($itemOS->osps_fk_cc_codigo)) {
//               $this->cancelaMovimentacao($itemOS->osps_fk_cc_codigo);
//            }

            $this->service_order_item_repository->destroy($item_id);
         }
      } catch (\Exception $exception) {
         $err[] = ["message" => $exception->getMessage()];
      }

      if(count($err)){
         return $err;
      }

      return true;
   }
}
