<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace Schaffen\ServiceOrder\ServiceOrder\Services;


class UpdateDiscountsFromServiceOrder
{
   public static function atualizarDescontos($descontos)
   {
      $descontos = \GuzzleHttp\json_decode($descontos);
      try {
         DB::beginTransaction();

         foreach ($descontos as $desconto) {
            $osps = OsProdutosServicos::findOrFail($desconto->osps_codigo);

            $osps->osps_desconto = number_format($desconto->osps_desconto, 2);
            $osps->osps_desconto_porcentagem = number_format($desconto->osps_desconto_porcentagem, 2);

            $osps->save();
         }

         DB::commit();
         Response::success("Desconto inserido com sucesso.");
      } catch (SCHException $e) {
         DB::rollback();
         return Response::faillure($e->getMessage(), $e->getTrace());
      } catch (\Exception $e) {
         DB::rollback();
         return Response::error($e->getMessage(), $e);
      }
   }
}
